<?php

namespace Drupal\gridstack\Plugin\gridstack\engine;

use Drupal\gridstack\GridStackDefault;

/**
 * Provides a GridStack Bootstrap 3 layout engine.
 *
 * @GridStackEngine(
 *   id = "bootstrap3",
 *   group = "bootstrap",
 *   hidden = "false",
 *   version = "3",
 *   label = @Translation("Bootstrap 3")
 * )
 */
class Bootstrap3 extends BootstrapBase {

  /**
   * {@inheritdoc}
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);

    $sizes = $this->sizes ?: GridStackDefault::breakpoints();
    array_pop($sizes);
    $this->sizes = $this->setSizes($sizes);
  }

  /**
   * {@inheritdoc}
   */
  protected function getVersionClasses() {
    $classes = parent::getVersionClasses();
    foreach (array_keys($this->sizes) as $size) {
      $hidden[] = "hidden-$size";
      $visible[] = "visible-$size";
    }

    $classes['hidden'] = $hidden;
    $classes['visible'] = $visible;

    return $classes;
  }

}
